<template>
	<div class="page-helper">
		<div class="page-list">
			<!-- <span>共{{ totalPage }}页 / {{ totalcount }}条</span> -->
			<span>{{langarr.total}} {{ totalcount }} {{totalcount >=2 ? langarr.results : langarr.result}}</span>
			<!-- <span class="page-item" @click="jumppage(1)">首页</span> -->
			<span class="page-item" :class="{'disabled': currentPage === 1}"  @click="prevPage"> < </span>
			<span class="page-ellipsis" v-if="showPrevMore" @click="showPrevPage">...</span>
			<span class="page-item" v-for="num in groupList" :class="{'page-current':currentPage===num}" :key="num"
				  @click="jumppage(num)">{{num}}</span>
			<span class="page-ellipsis" v-if="showNextMore" @click="showNextPage">...</span>
			<span class="page-item" :class="{'disabled': currentPage === totalPage}" @click="nextPage">></span>
			<!-- <span class="page-item" @click="jumppage(totalPage)">末页</span> -->
			<span class="page-pace">&nbsp;</span>
			{{langarr.showing}}
			<select class="page-select" @change="jumppage(currentPage)" v-model="currentSize">
			  <option v-for="size in pagesizearray" :key="size" :value="size">{{ size }}</option>
			</select>
			{{langarr.resultsper}}
			<!-- <span class="ml20">跳至</span>
			<span class="page-jump-to"><input type="type" v-model="jumpPageNumber"></span>
			<span>页</span>
			<span class="page-item jump-go-btn" @click="goPage(jumpPageNumber)">GO</span> -->
		</div>
	</div>
	
	
</template>
	<!-- 分页开始 -->
	
<script type="text/javascript">
 module.exports = {
     name: 'pageHelper',
    data () {
        return {
          currentPage: this.pagenumber,
          currentSize: this.pagesizearray[0],
          jumpPageNumber: 1,
          showPrevMore: false,
          showNextMore: false,
		  langarr:{
			  total:"",
			  
		  }
        }
      },
      props: {
        
        pagesizearray: {   //每页显示数量
          type: Array,
          default () {
            return [10]
          }
        },
		pagenumber: {   //当前页面
		  type: Number,
		  default: 1
		},
        totalcount: {   //总条数
          type: Number,
          default: 100
        },
        pageGroup: {   //连续页码个数
          type: Number,
          default: 5
        }
      },
      computed: {
        showPageHelper () {
          return this.totalcount > 0
        },
        totalPage () {   //总页数
          return Math.ceil(this.totalcount / this.currentSize);
        },
        groupList () {  //获取分页码
          const groupArray = []
          const totalPage = this.totalPage
          const pageGroup = this.pageGroup
          const _offset = (pageGroup - 1) / 2
          let current = this.currentPage
          const offset = {
            start: current - _offset,
            end: current + _offset
          }
		  // if(localStorage.getItem("langs")){
		  // 	this.langarr = JSON.parse(localStorage.getItem("langs"))
		  // 	console.log(JSON.stringify(this.langarr))
		  // }
          if (offset.start < 1) {
            offset.end = offset.end + (1 - offset.start)
            offset.start = 1
          }
          if (offset.end > totalPage) {
            offset.start = offset.start - (offset.end - totalPage)
            offset.end = totalPage
          }
          if (offset.start < 1) offset.start = 1
          this.showPrevMore = (offset.start > 1)
          this.showNextMore = (offset.end < totalPage)
          for (let i = offset.start; i <= offset.end; i++) {
            groupArray.push(i)
          }
          return groupArray
        }
      },
	  created() {
		  let that = this;
		  // console.log("pageplug---")
			// console.log(localStorage.getItem("langs"))
	  		// if(localStorage.getItem("langs")){
	  		// 	this.langarr = JSON.parse(localStorage.getItem("langs"))
	  		// 	console.log(JSON.stringify(this.langarr))
	  		// }
			setTimeout(function(){//重置banner
				// console.log("======================page")
				if(localStorage.getItem("langs")){
					that.langarr = JSON.parse(localStorage.getItem("langs"))
					// console.log(JSON.stringify(this.langarr))
				}
			},200)
			
	  },
      methods: {
        prevPage () {
          if (this.currentPage > 1) {
            this.jumppage(this.currentPage - 1)
          }
        },
        nextPage () {
          if (this.currentPage < this.totalPage) {
            this.jumppage(this.currentPage + 1)
          }
        },
        showPrevPage() {
          this.currentPage = this.currentPage - this.pageGroup > 0 ? this.currentPage - this.pageGroup : 1
        },
        showNextPage() {
          this.currentPage = this.currentPage + this.pageGroup < this.totalPage ? this.currentPage + this.pageGroup : this.totalPage
        },
        goPage (jumpPageNumber) {
          if(Number(jumpPageNumber) <= 0){
            jumpPageNumber = 1
          }if(Number(jumpPageNumber) >= this.totalPage){
            jumpPageNumber = this.totalPage
          }
          this.jumppage(Number(jumpPageNumber))
        },
        jumppage (pageNumber) {
          if (this.currentPage !== pageNumber) {  //点击的页码不是当前页码
            this.currentPage = pageNumber
          //父组件通过change方法来接受当前的页码
          this.$emit('jumppage', {currentPage: this.currentPage, currentSize: this.currentSize})
          }
        }
      },
      watch: {
        currentSize (newValue, oldValue) {
			
          if(newValue !== oldValue){
            if(this.currentPage >= this.totalPage){ //当前页面大于总页面数
              this.currentPage = this.totalPage
            }
            this.$emit('jumppage', {currentPage: this.currentPage, currentSize: this.currentSize})
          }
        }
      }
    
 };

</script>
</body>
</html>